bl_info = {
    "name" : "painting layer",
    "author" : "cgblender", 
    "description" : "",
    "blender" : (3, 6, 0),
    "version" : (1, 0, 0),
    "location" : "",
    "waring" : "",
    "doc_url": "", 
    "tracker_url": "", 
    "category" : "3D View" 
}


import bpy
import bpy.utils.previews

import os


def string_to_int(value):
    if value.isdigit():
        return int(value)
    return 0

def string_to_icon(value):
    if value in bpy.types.UILayout.bl_rna.functions["prop"].parameters["icon"].enum_items.keys():
        return bpy.types.UILayout.bl_rna.functions["prop"].parameters["icon"].enum_items[value].value
    return string_to_int(value)
    
def icon_to_string(value):
    for icon in bpy.types.UILayout.bl_rna.functions["prop"].parameters["icon"].enum_items:
        if icon.value == value:
            return icon.name
    return "NONE"
    
def enum_set_to_string(value):
    if type(value) == set:
        if len(value) > 0:
            return "[" + (", ").join(list(value)) + "]"
        return "[]"
    return value
    
def string_to_type(value, to_type, default):
    try:
        value = to_type(value)
    except:
        value = default
    return value

addon_keymaps = {}
_icons = None
painting_layer_addon = {}



class SNA_OT_Operator_3E6D5(bpy.types.Operator):
    bl_idname = "sna.operator_3e6d5"
    bl_label = "Operator"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}
    
    
    @classmethod
    def poll(cls, context):
        return not False
    def execute(self, context):
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'painting layer.blend') + r'\NodeTree', filename='painting layer', link=False)
        bpy.ops.object.modifier_add('INVOKE_DEFAULT', type='NODES')
        bpy.context.active_object.modifiers.active.node_group = bpy.data.node_groups['painting layer']
        return {"FINISHED"}
    
    def invoke(self, context, event):
        
        
        return self.execute(context)
class SNA_PT_PAINTING_LAYER_9FA74(bpy.types.Panel):
    bl_label = 'Painting Layer'
    bl_idname = 'SNA_PT_PAINTING_LAYER_9FA74'
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_context = ''
    bl_category = 'PL'
    bl_order = 0
    bl_options = {'HIDE_HEADER'}
    
    @classmethod
    def poll(cls, context):
        return not (False)
    
    def draw_header(self, context):
        layout = self.layout
        
    def draw(self, context):
        layout = self.layout
        op = layout.operator('sna.operator_3e6d5', text='Add Painting Layer', icon_value=0, emboss=True, depress=False)
        op = layout.operator('view3d.object_as_camera', text='Set Active', icon_value=0, emboss=True, depress=False)
        layout.prop(bpy.context.active_object.modifiers.active.node_group.nodes['Object Info'].inputs[0], 'default_value', text='Set  camera', icon_value=240, emboss=True)
        layout.prop(bpy.context.view_layer.objects.active.modifiers['GeometryNodes'], '["Input_2"]', text='Density', icon_value=348, emboss=True)
        layout.prop(bpy.context.view_layer.objects.active.modifiers['GeometryNodes'], '["Input_5"]', text='Scale Random', icon_value=408, emboss=True)
        layout.prop(bpy.data.materials['brush.001'].node_tree.nodes['Mix.002'].inputs[6], 'default_value', text='Base Color', icon_value=79, emboss=True)
        
        



def register():
    
    global _icons
    _icons = bpy.utils.previews.new()
    
    
    bpy.utils.register_class(SNA_OT_Operator_3E6D5)
    bpy.utils.register_class(SNA_PT_PAINTING_LAYER_9FA74)

def unregister():
    
    global _icons
    bpy.utils.previews.remove(_icons)
    
    wm = bpy.context.window_manager
    kc = wm.keyconfigs.addon
    for km, kmi in addon_keymaps.values():
        km.keymap_items.remove(kmi)
    addon_keymaps.clear()
    
    
    bpy.utils.unregister_class(SNA_OT_Operator_3E6D5)
    bpy.utils.unregister_class(SNA_PT_PAINTING_LAYER_9FA74)

